//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  1
#property indicator_width4  1

//
//
//
//
//

extern string TimeFrame   = "current time frame";
extern int    HmaLength1  = 14;
extern int    Price1      =  0;
extern double Power1      =  2;
extern int    HmaLength2  = 14;
extern int    Price2      =  0;
extern double Power2      = 0.5;
extern double UpArrowGap  = 0.5;
extern double DnArrowGap  = 0.5;
extern bool   Interpolate = true;

//
//
//
//
//

double hull1[];
double hull2[];
double arrUp[];
double arrDn[];
double slope1[];
double slope2[];
double trend[];

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,hull1);
      SetIndexBuffer(1,hull2);
      SetIndexBuffer(2,arrUp); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,241);
      SetIndexBuffer(3,arrDn); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,242);
      SetIndexBuffer(4,slope1);
      SetIndexBuffer(5,slope2);
      SetIndexBuffer(6,trend);

      //
      //
      //
      //
      //
         
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);

      //
      //
      //
      //
      //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" Hull moving average x 2("+HmaLength1+","+HmaLength2+")");
   return(0);
}



//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { hull1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      int HalfPeriod1 = MathFloor(HmaLength1/2);
      int HullPeriod1 = MathFloor(MathSqrt(HmaLength1));
      int HalfPeriod2 = MathFloor(HmaLength2/2);
      int HullPeriod2 = MathFloor(MathSqrt(HmaLength2));
      
      //
      //
      //
      //
      //
      
      for(int i=limit; i>=0; i--)
      {
         double price1    = iMA(NULL,0,1,0,MODE_SMA,Price1,i);
         double price2    = iMA(NULL,0,1,0,MODE_SMA,Price2,i);
                hull1[i]  = iLwmp(2.0*iLwmp(price1,HalfPeriod1,Power1,i,0)-iLwmp(price1,HmaLength1,Power1,i,1),HullPeriod1,Power1,i,2);
                hull2[i]  = iLwmp(2.0*iLwmp(price2,HalfPeriod2,Power2,i,3)-iLwmp(price2,HmaLength2,Power2,i,4),HullPeriod2,Power2,i,5);
                slope1[i] = slope1[i+1];
                slope2[i] = slope2[i+1];
                trend[i]  = trend[i+1];
                  if (hull1[i]>hull1[i+1]) slope1[i]=  1;
                  if (hull1[i]<hull1[i+1]) slope1[i]= -1;
                  if (hull2[i]>hull2[i+1]) slope2[i]=  1;
                  if (hull2[i]<hull2[i+1]) slope2[i]= -1;
                  if (hull1[i]>hull2[i])   trend[i] =  1;
                  if (hull1[i]<hull2[i])   trend[i] = -1;
               arrUp[i] = EMPTY_VALUE;                  
               arrDn[i] = EMPTY_VALUE;                  
                  if (trend[i] != trend[i+1])
                     if (trend[i]==1)
                           arrUp[i] = hull2[i]-iATR(NULL,0,10,i)*UpArrowGap;
                     else  arrDn[i] = hull2[i]+iATR(NULL,0,10,i)*DnArrowGap;
      }            
      return(0);
   }
   
   //
   //
   //
   //
   //
   

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      int x = iBarShift(NULL,timeFrame,Time[i+1]);
         hull1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HmaLength1,Price1,Power1,HmaLength2,Price2,Power2,0,y);
         hull2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HmaLength1,Price1,Power1,HmaLength2,Price2,Power2,1,y);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HmaLength1,Price1,Power1,HmaLength2,Price2,Power2,6,y);
         arrUp[i] = EMPTY_VALUE;                  
         arrDn[i] = EMPTY_VALUE;                  
         if (x!=y)
         {
            if (trend[i] != trend[i+1])
                if (trend[i]==1)
                     arrUp[i] = hull2[i]-iATR(NULL,0,10,i)*0.5;
               else  arrDn[i] = hull2[i]+iATR(NULL,0,10,i)*0.5;
         }

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int j = 1; j < n; j++)
            {
               hull1[i+j] = hull1[i] + (hull1[i+n]-hull1[i])*j/n;
               hull2[i+j] = hull2[i] + (hull2[i+n]-hull2[i])*j/n;
            }               
   }
   return(0);         
}

  
//------------------------------------------------------------------
//                                                                 
//------------------------------------------------------------------
//
//
//
//
//

double workLwmp[][6];
double iLwmp(double price, double period, double power, int r, int instanceNo=0)
{
   if (ArrayRange(workLwmp,0)!= Bars) ArrayResize(workLwmp,Bars); r = Bars-r-1;
   
   //
   //
   //
   //
   //
   
   workLwmp[r][instanceNo] = price;
      double sumw = MathPow(period,power);
      double sum  = sumw*price;
      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = MathPow(period-k,power);
                sumw  += weight;
                sum   += weight*workLwmp[r-k][instanceNo];  
      }             
   return(sum/sumw);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}